searchNodes=[{"ref":"Xgit.html","title":"Xgit","type":"module","doc":"Just a tiny little project."},{"ref":"Xgit.html#start/2","title":"Xgit.start/2","type":"function","doc":"Start Xgit application."},{"ref":"Xgit.Core.ContentSource.html","title":"Xgit.Core.ContentSource","type":"protocol","doc":"Protocol used for reading object content from various sources."},{"ref":"Xgit.Core.ContentSource.html#length/1","title":"Xgit.Core.ContentSource.length/1","type":"function","doc":"Calculate the length (in bytes) of the content."},{"ref":"Xgit.Core.ContentSource.html#stream/1","title":"Xgit.Core.ContentSource.stream/1","type":"function","doc":"Return a stream which can be used for reading the content."},{"ref":"Xgit.Core.ContentSource.html#t:t/0","title":"Xgit.Core.ContentSource.t/0","type":"type","doc":"Any value for which ContentSource protocol is implemented."},{"ref":"Xgit.Core.DirCache.html","title":"Xgit.Core.DirCache","type":"module","doc":"A directory cache records the current (intended) contents of a working tree when last scanned or created by git. In Xgit, the DirCache structure is an abstract, in-memory data structure without any tie to a specific persistence mechanism. Persistence is implemented by a specific implementation of the Xgit.Repository behaviour. This content is commonly persisted on disk as an index file at the root of the git tree. The module Xgit.Repository.WorkingTree.ParseIndexFile can parse that file format. Changes in the working tree can be detected by comparing the modification times to the cached modification time within the dir cache. Index files are also used during merges, where the merge happens within the index file first, and the working directory is updated as a post-merge step. Conflicts are stored in the index file to allow tool (and human) based resolutions to be easily performed."},{"ref":"Xgit.Core.DirCache.html#add_entries/2","title":"Xgit.Core.DirCache.add_entries/2","type":"function","doc":"Returns a dir cache that has new directory entries added in. In the event of a collision between entries (same path and stage), the existing entry will be replaced by the new one. Parameters entries a list of entries to add to the existing dir cache Return Value {:ok, dir_cache} where dir_cache is the original dir_cache with the new entries added (and properly sorted). {:error, :invalid_dir_cache} if the original dir_cache was invalid. {:error, :invalid_entries} if one or more of the entries is invalid. {:error, :duplicate_entries} if one or more of the entries in the new list are duplicates of other entries in the new list. (As stated earlier, duplicates from the original list are acceptable; in that event, the new entry will replace the old one.)"},{"ref":"Xgit.Core.DirCache.html#empty/0","title":"Xgit.Core.DirCache.empty/0","type":"function","doc":"Returns a dir cache that is the canonical &quot;empty&quot; dir cache (i.e. contains no entries)."},{"ref":"Xgit.Core.DirCache.html#remove_entries/2","title":"Xgit.Core.DirCache.remove_entries/2","type":"function","doc":"Returns a dir cache that has some directory entries removed. Parameters entries_to_remove is a list of {path, stage} tuples identifying tuples to be removed. path should be a byte list for the path. stage should be 0..3 or :all, meaning any entry that matches the path, regardless of stage, should be removed. Return Value {:ok, dir_cache} where dir_cache is the original dir_cache with any matching entries removed. {:error, :invalid_dir_cache} if the original dir_cache was invalid. {:error, :invalid_entries} if one or more of the entries is invalid."},{"ref":"Xgit.Core.DirCache.html#valid?/1","title":"Xgit.Core.DirCache.valid?/1","type":"function","doc":"Return true if the value is a DirCache struct that is valid. All of the following must be true for this to occur: The value is a DirCache struct. The version is supported by Xgit. (Currently, only version 2 is supported.) The entry_count matches the actual number of entries. The entries are properly sorted. All entries are valid, as determined by Xgit.Core.DirCache.Entry.valid?/1."},{"ref":"Xgit.Core.DirCache.html#t:add_entries_reason/0","title":"Xgit.Core.DirCache.add_entries_reason/0","type":"type","doc":"Error reason codes returned by add_entries/2."},{"ref":"Xgit.Core.DirCache.html#t:entry_to_remove/0","title":"Xgit.Core.DirCache.entry_to_remove/0","type":"type","doc":"An entry for the remove option for remove_entries/2."},{"ref":"Xgit.Core.DirCache.html#t:remove_entries_reason/0","title":"Xgit.Core.DirCache.remove_entries_reason/0","type":"type","doc":"Error reason codes returned by remove_entries/2."},{"ref":"Xgit.Core.DirCache.html#t:t/0","title":"Xgit.Core.DirCache.t/0","type":"type","doc":"This struct describes an entire working tree as understood by git. Struct Members :version: the version number as read from disk (typically 2, 3, or 4) :entry_count: the number of items in entries :entries: a list of Entry structs in sorted order :extensions: a list of Extension structs (not yet implemented)"},{"ref":"Xgit.Core.DirCache.html#t:version/0","title":"Xgit.Core.DirCache.version/0","type":"type","doc":"Version number for an index file."},{"ref":"Xgit.Core.DirCache.Entry.html","title":"Xgit.Core.DirCache.Entry","type":"module","doc":"A single file (or stage of a file) in a directory cache. An entry represents exactly one stage of a file. If a file path is unmerged then multiple instances may appear for the same path name."},{"ref":"Xgit.Core.DirCache.Entry.html#compare/2","title":"Xgit.Core.DirCache.Entry.compare/2","type":"function","doc":"Compare two entries according to git dir cache entry sort ordering rules. For this purpose, only the following fields are considered (in this priority order): :name :stage Return Value :lt if entry1 sorts before entry2. :eq if they are the same. :gt if entry1 sorts after entry2."},{"ref":"Xgit.Core.DirCache.Entry.html#valid?/1","title":"Xgit.Core.DirCache.Entry.valid?/1","type":"function","doc":"Return true if this entry struct describes a valid dir cache entry."},{"ref":"Xgit.Core.DirCache.Entry.html#t:stage/0","title":"Xgit.Core.DirCache.Entry.stage/0","type":"type","doc":"Merge status (stage)."},{"ref":"Xgit.Core.DirCache.Entry.html#t:stage_match/0","title":"Xgit.Core.DirCache.Entry.stage_match/0","type":"type","doc":"Merge status (stage) for matching a remove request. (Includes :all to match any stage.)"},{"ref":"Xgit.Core.DirCache.Entry.html#t:t/0","title":"Xgit.Core.DirCache.Entry.t/0","type":"type","doc":"A single file (or stage of a file) in a directory cache. An entry represents exactly one stage of a file. If a file path is unmerged then multiple instances may appear for the same path name. Consult the documentation for git index file format for a more detailed description of each item. Struct Members name: (FilePath.t) entry path name, relative to top-level directory (without leading slash) stage: (0..3) merge status object_id: (ObjectId.t) SHA-1 for the represented object mode: (FileMode.t) size: (integer) on-disk size, possibly truncated to 32 bits ctime: (integer) the last time the file&#39;s metadata changed ctime_ns: (integer) nanosecond fraction of ctime (if available) mtime: (integer) the last time a file&#39;s contents changed mtime_ns: (integer) nanosecond fractino of mtime (if available) dev: (integer) ino: (integer) uid: (integer) gid: (integer) assume_valid?: (boolean) extended?: (boolean) skip_worktree?: (boolean) intent_to_add?: (boolean)"},{"ref":"Xgit.Core.FileContentSource.html","title":"Xgit.Core.FileContentSource","type":"module","doc":"Implements Xgit.Core.ContentSource to read content from a file on disk."},{"ref":"Xgit.Core.FileContentSource.html#new/1","title":"Xgit.Core.FileContentSource.new/1","type":"function","doc":"Creates an Xgit.Core.FileContentSource for a file on disk."},{"ref":"Xgit.Core.FileContentSource.html#t:t/0","title":"Xgit.Core.FileContentSource.t/0","type":"type","doc":"Describes a file on disk which will be used for reading content."},{"ref":"Xgit.Core.FileMode.html","title":"Xgit.Core.FileMode","type":"module","doc":"Describes the file type as represented on disk."},{"ref":"Xgit.Core.FileMode.html#executable_file/0","title":"Xgit.Core.FileMode.executable_file/0","type":"function","doc":"Mode indicating an entry is an executable file."},{"ref":"Xgit.Core.FileMode.html#executable_file?/1","title":"Xgit.Core.FileMode.executable_file?/1","type":"function","doc":"Return true if the file mode represents an executable file."},{"ref":"Xgit.Core.FileMode.html#gitlink/0","title":"Xgit.Core.FileMode.gitlink/0","type":"function","doc":"Mode indicating an entry is a submodule commit in another repository."},{"ref":"Xgit.Core.FileMode.html#gitlink?/1","title":"Xgit.Core.FileMode.gitlink?/1","type":"function","doc":"Return true if the file mode represents a submodule commit in another repository."},{"ref":"Xgit.Core.FileMode.html#is_file_mode/1","title":"Xgit.Core.FileMode.is_file_mode/1","type":"macro","doc":"This guard requires the value to be one of the known git file mode values."},{"ref":"Xgit.Core.FileMode.html#regular_file/0","title":"Xgit.Core.FileMode.regular_file/0","type":"function","doc":"Mode indicating an entry is a non-executable file."},{"ref":"Xgit.Core.FileMode.html#regular_file?/1","title":"Xgit.Core.FileMode.regular_file?/1","type":"function","doc":"Return true if the file mode represents a regular file."},{"ref":"Xgit.Core.FileMode.html#symlink/0","title":"Xgit.Core.FileMode.symlink/0","type":"function","doc":"Mode indicating an entry is a symbolic link."},{"ref":"Xgit.Core.FileMode.html#symlink?/1","title":"Xgit.Core.FileMode.symlink?/1","type":"function","doc":"Return true if the file mode a symbolic link."},{"ref":"Xgit.Core.FileMode.html#tree/0","title":"Xgit.Core.FileMode.tree/0","type":"function","doc":"Mode indicating an entry is a tree (aka directory)."},{"ref":"Xgit.Core.FileMode.html#tree?/1","title":"Xgit.Core.FileMode.tree?/1","type":"function","doc":"Return true if the file mode represents a tree."},{"ref":"Xgit.Core.FileMode.html#valid?/1","title":"Xgit.Core.FileMode.valid?/1","type":"function","doc":"Return true if the value is one of the known file mode values."},{"ref":"Xgit.Core.FileMode.html#t:t/0","title":"Xgit.Core.FileMode.t/0","type":"type","doc":"An integer describing the file type as represented on disk. Git uses a variation on the Unix file permissions flags to denote a file&#39;s intended type on disk. The following values are recognized: 0o100644 - normal file 0o100755 - executable file 0o120000 - symbolic link 0o040000 - tree (subdirectory) 0o160000 - submodule (aka gitlink) This module is intended to be used. Doing so will create an alias to the module so as to make FileMode.t available for typespecs and will import the is_file_mode/1 guard."},{"ref":"Xgit.Core.FilePath.html","title":"Xgit.Core.FilePath","type":"module","doc":"Describes a file path as stored in a git repo. Paths are always stored as a list of bytes. The git specification does not explicitly specify an encoding, but most commonly the path is interpreted as UTF-8. We use byte lists here to avoid confusion and possible misintepretation in Elixir&#39;s String type for non-UTF-8 paths. Paths are alternately referred to in git as &quot;file name,&quot; &quot;path,&quot; &quot;path name,&quot; and &quot;object name.&quot; We&#39;re using the name FilePath to avoid collision with Elixir&#39;s built-in Path module and to make it clear that we&#39;re talking about the path to where a file is stored on disk."},{"ref":"Xgit.Core.FilePath.html#check_path/2","title":"Xgit.Core.FilePath.check_path/2","type":"function","doc":"Check the provided path to see if it is a valid path within a git repository. The rules enforced here are slightly different from what is allowed in a tree object in that we allow / characters to build hierarchical paths. Parameters path is a UTF-8 byte list containing the path to be tested. Options windows?: true to additionally verify that the path is permissible on Windows file systems macosx?: true to additionally verify that the path is permissible on Mac OS X file systems Return Values :ok if the name is permissible given the constraints chosen above {:error, :invalid_name} if the name is not permissible {:error, :empty_path} if the name is empty {:error, :absolute_path} if the name starts with a / {:error, :duplicate_slash} if the name contains two / characters in a row {:error, :trailing_slash} if the name contains a trailing / See also: error return values from check_path_segment/2."},{"ref":"Xgit.Core.FilePath.html#check_path_segment/2","title":"Xgit.Core.FilePath.check_path_segment/2","type":"function","doc":"Check the provided path segment to see if it is a valid path within a git tree object. Parameters path is a UTF-8 byte list containing the path segment to be tested. Options windows?: true to additionally verify that the path is permissible on Windows file systems macosx?: true to additionally verify that the path is permissible on Mac OS X file systems Return Values :ok if the name is permissible given the constraints chosen above {:error, :invalid_name} if the name is not permissible {:error, :empty_name} if the name is empty {:error, :reserved_name} if the name is reserved for git&#39;s use (i.e. .git) {:error, :invalid_utf8_sequence} if the name contains certain incomplete UTF-8 byte sequences (only when macosx?: true is selected) {:error, :invalid_name_on_windows} if the name contains characters that are not allowed on Windows file systems (only when windows?: true is selected) {:error, :windows_device_name} if the name matches a Windows device name (aux, etc.) (only when windows?: true is selected)"},{"ref":"Xgit.Core.FilePath.html#compare/4","title":"Xgit.Core.FilePath.compare/4","type":"function","doc":"Compare two paths according to git path sort ordering rules. Return Value :lt if path1 sorts before path2. :eq if they are the same. :gt if path1 sorts after path2."},{"ref":"Xgit.Core.FilePath.html#compare_same_name/3","title":"Xgit.Core.FilePath.compare_same_name/3","type":"function","doc":"Compare two paths, checking for identical name. Unlike compare/4, this method returns :eq when the paths have the same characters in their names, even if the mode differs. It is intended for use in validation routines detecting duplicate entries. Parameters mode2 is the mode of the second file. Trees are sorted as though List.last(path2) == ?/, even if no such character exists. Return Value Returns :eq if the names are identical and a conflict exists between path1 and path2, as they share the same name. Returns :lt if all possible occurrences of path1 sort before path2 and no conflict can happen. In a properly sorted tree there are no other occurrences of path1 and therefore there are no duplicate names. Returns :gt when it is possible for a duplicate occurrence of path1 to appear later, after path2. Callers should continue to examine candidates for path2 until the method returns one of the other return values."},{"ref":"Xgit.Core.FilePath.html#gitmodules?/2","title":"Xgit.Core.FilePath.gitmodules?/2","type":"function","doc":"Return true if the filename could be read as a .gitmodules file when checked out to the working directory. This would seem like a simple comparison, but some filesystems have peculiar rules for normalizing filenames: NTFS has backward-compatibility support for 8.3 synonyms of long file names. (See https://web.archive.org/web/20160318181041/https://usn.pw/blog/gen/2015/06/09/filenames/ for details.) NTFS is also case-insensitive. MacOS&#39;s HFS+ folds away ignorable Unicode characters in addition to case folding. Parameters path is a UTF-8 byte list containing the path to be tested. Options By default, this function will only check for the plain .gitmodules name. windows?: true to additionally check for any path that might be treated as a .gitmodules file on Windows file systems macosx?: true to additionally check for any path that might be treated as a .gitmodules file on Mac OS X file systems"},{"ref":"Xgit.Core.FilePath.html#strip_trailing_separator/1","title":"Xgit.Core.FilePath.strip_trailing_separator/1","type":"function","doc":"Remove trailing / if present."},{"ref":"Xgit.Core.FilePath.html#valid?/2","title":"Xgit.Core.FilePath.valid?/2","type":"function","doc":"Return true if the value is a valid file path. This performs the same checks as check_path/2, but folds away all of the potential error values to false. Parameters path is a UTF-8 byte list containing the path to be tested. Options windows?: true to additionally verify that the path is permissible on Windows file systems macosx?: true to additionally verify that the path is permissible on Mac OS X file systems"},{"ref":"Xgit.Core.FilePath.html#t:check_path_reason/0","title":"Xgit.Core.FilePath.check_path_reason/0","type":"type","doc":"Error codes which can be returned by check_path/2."},{"ref":"Xgit.Core.FilePath.html#t:check_path_segment_reason/0","title":"Xgit.Core.FilePath.check_path_segment_reason/0","type":"type","doc":"Error codes which can be returned by check_path_segment/2."},{"ref":"Xgit.Core.FilePath.html#t:t/0","title":"Xgit.Core.FilePath.t/0","type":"type","doc":"Representation of a file&#39;s path within a git repo. Typically, though not necessarily, interpreted as UTF-8."},{"ref":"Xgit.Core.Object.html","title":"Xgit.Core.Object","type":"module","doc":"Describes a single object stored (or about to be stored) in a git repository. This struct is constructed, modified, and shared as a working description of how to find and describe an object before it gets written to a repository."},{"ref":"Xgit.Core.Object.html#check/2","title":"Xgit.Core.Object.check/2","type":"function","doc":"Verify that a proposed object is valid. This function performs a detailed check on the content of the object. For a simpler verification that the Object struct is itself valid, see valid?/1. Verifications made by this function only check that the fields of an object are formatted correctly. The object ID checksum of the object is not verified, and connectivity links between objects are also not verified. It&#39;s assumed that the caller can provide both of these validations on its own. Options By default, this function will only enforce Posix file name restrictions. :macosx?: true to also enforce Mac OS X path name restrictions :windows?: true to also enforce Windows path name restrictions Return Value :ok if the object is successfully validated. {:error, :invalid_type} if the object&#39;s type is unknown. {:error, :no_tree_header} if the object is a commit but does not contain a valid tree header. {:error, :invalid_tree} if the object is a commit but the tree object ID is invalid. {:error, :invalid_parent} if the object is a commit but one of the parent headers is invalid. {:error, :no_author} if the object is a commit but there is no author header. {:error, :no_committer} if the object is a commit but there is no committer header. {:error, :no_object_header} if the object is a tag but there is no object header. {:error, :invalid_object} if the object is a tag but the object ID is invalid. {:error, :no_type_header} if the object is a tag but there is no type header. {:error, :invalid_tagger} if the object is a tag but one of the tagger headers is invalid. {:error, :bad_date} if the object is a tag or a commit but has a malformed date entry. {:error, :bad_email} if the object is a tag or a commit but has a malformed e-mail address. {:error, :missing_email} if the object is a tag or a commit but has a missing e-mail address where one is expected. {:error, :missing_space_before_date} if the object is a tag or a commit but has no space preceding the place where a date is expected. {:error, :bad_time_zone} if the object is a tag or a commit but has a malformed time zone entry. {:error, :invalid_file_mode} if the object is a tree but one of the file modes is invalid. {:error, :truncated_in_name} if the object is a tree but one of the file names is incomplete. {:error, :duplicate_entry_names} if the object is a tree and contains duplicate entry names. {:error, :incorrectly_sorted} if the object is a tree and the entries are not in alphabetical order. {:error, :truncated_in_object_id} if the object is a tree and one of the object IDs is invalid. {:error, :null_sha1} if the object is a tree and one of the object IDs is all zeros. {:error, :invalid_mode} if the object is a tree and one of the file modes is incomplete. See also error responses from Xgit.Core.FilePath.check_path/2 and Xgit.Core.FilePath.check_path_segment/2."},{"ref":"Xgit.Core.Object.html#valid?/1","title":"Xgit.Core.Object.valid?/1","type":"function","doc":"Return true if the struct describes a valid object. IMPORTANT: This validation only verifies that the struct itself is valid. It does not inspect the content of the object. That check can be performed by check/2."},{"ref":"Xgit.Core.Object.html#t:check_reason/0","title":"Xgit.Core.Object.check_reason/0","type":"type","doc":"Error codes which can be returned by check/2."},{"ref":"Xgit.Core.Object.html#t:t/0","title":"Xgit.Core.Object.t/0","type":"type","doc":"This struct describes a single object stored or about to be stored in a git repository. Struct Members :type: the object&#39;s type (:blob, :tree, :commit, or :tag) :content: how to obtain the content (see Xgit.Core.ContentSource) :size: size (in bytes) of the object or :unknown :id: object ID (40 chars hex) of the object or :unknown"},{"ref":"Xgit.Core.ObjectId.html","title":"Xgit.Core.ObjectId","type":"module","doc":"An object ID is a string that identifies an object within a repository. This string must match the format for a SHA-1 hash (i.e. 40 characters of lowercase hex)."},{"ref":"Xgit.Core.ObjectId.html#calculate_id/2","title":"Xgit.Core.ObjectId.calculate_id/2","type":"function","doc":"Assign an object ID for a given data blob. No validation is performed on the content. Parameters data describes how to read the data. (See Xgit.Core.ContentSource.) type is the intended git object type for this data. (See Xgit.Core.ObjectType.) Return Value The object ID. (See Xgit.Core.ObjectId.)"},{"ref":"Xgit.Core.ObjectId.html#from_hex_charlist/1","title":"Xgit.Core.ObjectId.from_hex_charlist/1","type":"function","doc":"Read an object ID from a hex string (charlist). Return Value If a valid ID is found, returns {id, next} where id is the matched ID as a string and next is the remainder of the charlist after the matched ID. If no such ID is found, returns false."},{"ref":"Xgit.Core.ObjectId.html#valid?/1","title":"Xgit.Core.ObjectId.valid?/1","type":"function","doc":"Returns true if the value is a valid object ID. (In other words, is it a string containing 40 characters of lowercase hex?)"},{"ref":"Xgit.Core.ObjectId.html#zero/0","title":"Xgit.Core.ObjectId.zero/0","type":"function","doc":"Get the special all-null object ID, often used to stand-in for no object."},{"ref":"Xgit.Core.ObjectId.html#t:t/0","title":"Xgit.Core.ObjectId.t/0","type":"type","doc":"A string containing 40 bytes of lowercase hex digits."},{"ref":"Xgit.Core.ObjectType.html","title":"Xgit.Core.ObjectType","type":"module","doc":"Describes the known git object types. There are four distinct object types that can be stored in a git repository. Xgit communicates internally about these object types using the following atoms: :blob :tree :commit :tag This module is intended to be used. Doing so will create an alias to the module so as to make ObjectType.t available for typespecs and will import the is_object_type/1 guard."},{"ref":"Xgit.Core.ObjectType.html#is_object_type/1","title":"Xgit.Core.ObjectType.is_object_type/1","type":"macro","doc":"This guard requires the value to be one of the four known git object types."},{"ref":"Xgit.Core.ObjectType.html#valid?/1","title":"Xgit.Core.ObjectType.valid?/1","type":"function","doc":"Return true if the value is one of the four known git object types."},{"ref":"Xgit.Core.ObjectType.html#t:t/0","title":"Xgit.Core.ObjectType.t/0","type":"type","doc":"One of the four known git object types, expressed as an atom."},{"ref":"Xgit.Core.PersonIdent.html","title":"Xgit.Core.PersonIdent","type":"module","doc":"A combination of a person identity and time in git."},{"ref":"Xgit.Core.PersonIdent.html#format_timezone/1","title":"Xgit.Core.PersonIdent.format_timezone/1","type":"function","doc":"Formats a timezone offset."},{"ref":"Xgit.Core.PersonIdent.html#from_byte_list/1","title":"Xgit.Core.PersonIdent.from_byte_list/1","type":"function","doc":"Parse a name line (e.g. author, committer, tagger) into a PersonIdent struct. Parameters b should be a charlist of an &quot;author&quot; or &quot;committer&quot; line pointing to the character after the header name and space. The functions Xgit.Util.RawParseUtils.author/1 and Xgit.Util.RawParseUtils.committer/1 will return suitable charlists. Return Value Returns a PersonIdent struct or nil if the charlist did not point to a properly-formatted identity."},{"ref":"Xgit.Core.PersonIdent.html#sanitized/1","title":"Xgit.Core.PersonIdent.sanitized/1","type":"function","doc":"Sanitize the given string for use in an identity and append to output. Trims whitespace from both ends and special characters \\n &lt; &gt; that interfere with parsing; appends all other characters to the output."},{"ref":"Xgit.Core.PersonIdent.html#to_external_string/1","title":"Xgit.Core.PersonIdent.to_external_string/1","type":"function","doc":"Formats the person identity for git storage."},{"ref":"Xgit.Core.PersonIdent.html#valid?/1","title":"Xgit.Core.PersonIdent.valid?/1","type":"function","doc":"Returns true if the struct is a valid PersonIdent."},{"ref":"Xgit.Core.PersonIdent.html#t:t/0","title":"Xgit.Core.PersonIdent.t/0","type":"type","doc":"The tuple of name, email, time, and time zone that specifies who wrote or committed something. Struct Members :name: (string) human-readable name of the author or committer :email: (string) e-mail address for this person :when: (integer) time in the Unix epoch in milliseconds :tz_offset: (integer) time zone offset from GMT in minutes"},{"ref":"Xgit.Core.PersonIdent.html#t:tz_offset/0","title":"Xgit.Core.PersonIdent.tz_offset/0","type":"type","doc":"Time zone offset in minutes +/- from GMT."},{"ref":"Xgit.Plumbing.CatFile.html","title":"Xgit.Plumbing.CatFile","type":"module","doc":"Retrieves the content, type, and size information for a single object in a repository&#39;s object store. Analogous to the first form of git cat-file."},{"ref":"Xgit.Plumbing.CatFile.html#run/2","title":"Xgit.Plumbing.CatFile.run/2","type":"function","doc":"Retrieves the content, type, and size information for a single object in a repository&#39;s object store. Parameters repository is the Xgit.Repository (PID) to search for the object. object_id is a string identifying the object. Return Value {:ok, object} if the object could be found. object is an instance of Xgit.Core.Object and can be used to retrieve content and other information about the underlying git object. {:error, :invalid_repository} if repository doesn&#39;t represent a valid Xgit.Repository process. {:error, :invalid_object_id} if object_id can&#39;t be parsed as a valid git object ID. {:error, :not_found} if the object does not exist in the database. {:error, :invalid_object} if object was found, but invalid."},{"ref":"Xgit.Plumbing.CatFile.html#t:reason/0","title":"Xgit.Plumbing.CatFile.reason/0","type":"type","doc":"Reason codes that can be returned by run/2."},{"ref":"Xgit.Plumbing.HashObject.html","title":"Xgit.Plumbing.HashObject","type":"module","doc":"Computes an object ID and optionally writes that into the repository&#39;s object store. Analogous to git hash-object."},{"ref":"Xgit.Plumbing.HashObject.html#run/2","title":"Xgit.Plumbing.HashObject.run/2","type":"function","doc":"Computes an object ID and optionally writes that into the repository&#39;s object store. Parameters content describes how this function should obtain the content. (See Xgit.Core.ContentSource.) Options :type: the object&#39;s type Type: Xgit.Core.ObjectType Default: :blob See -t option on git hash-object. :validate?: true to verify that the object is valid for :type Type: boolean Default: true This is the inverse of the --literally option on git hash-object. :repo: where the content should be stored Type: Xgit.Repository (PID) Default: nil :write?: true to write the object into the repository Type: boolean Default: false This option is meaningless if :repo is not specified. See -w option on git hash-object. TO DO: There is no support, at present, for filters as defined in a .gitattributes file. See issue #18. Return Values {:ok, object_id} if the object could be validated and assigned an ID. {:error, :reason} if unable. The relevant reason codes may come from: Xgit.Core.FilePath.check_path/2 Xgit.Core.FilePath.check_path_segment/2 Xgit.Core.Object.check/2 Xgit.Repository.put_loose_object/2."},{"ref":"Xgit.Plumbing.LsFiles.Stage.html","title":"Xgit.Plumbing.LsFiles.Stage","type":"module","doc":"Show information about files in the index. Analogous to git ls-files --stage."},{"ref":"Xgit.Plumbing.LsFiles.Stage.html#run/1","title":"Xgit.Plumbing.LsFiles.Stage.run/1","type":"function","doc":"Retrieves information about files in the working tree as described by the index file. Parameters repository is the Xgit.Repository (PID) to search for the object. Return Value {:ok, entries}. entries will be a list of Xgit.Core.DirCache.Entry structs in sorted order. {:error, :invalid_repository} if repository doesn&#39;t represent a valid Xgit.Repository process. {:error, :bare} if repository doesn&#39;t have a working tree. {:error, reason} if the index file for repository isn&#39;t valid. (See Xgit.Repository.WorkingTree.ParseIndexFile.from_iodevice/1 for possible reason codes.)"},{"ref":"Xgit.Plumbing.LsFiles.Stage.html#t:reason/0","title":"Xgit.Plumbing.LsFiles.Stage.reason/0","type":"type","doc":"Reason codes that can be returned by run/1."},{"ref":"Xgit.Plumbing.UpdateIndex.CacheInfo.html","title":"Xgit.Plumbing.UpdateIndex.CacheInfo","type":"module","doc":"Update the index file to reflect new contents. Analogous to the --cacheinfo form of git update-index."},{"ref":"Xgit.Plumbing.UpdateIndex.CacheInfo.html#run/3","title":"Xgit.Plumbing.UpdateIndex.CacheInfo.run/3","type":"function","doc":"Update the index file to reflect new contents. Parameters repository is the Xgit.Repository (PID) to which the new entries should be written. add: a list of tuples of {mode, object_id, path} entries to add to the dir cache. In the event of collisions with existing entries, the existing entries will be replaced with the corresponding new entries. remove: a list of paths to remove from the dir cache. All versions of the file, regardless of stage, will be removed. Return Value :ok if successful. {:error, :invalid_repository} if repository doesn&#39;t represent a valid Xgit.Repository process. {:error, :bare} if repository doesn&#39;t have a working tree. {:error, :invalid_entry} if any tuple passed to add or remove was invalid. {:error, :reason} if unable. The relevant reason codes may come from Xgit.Repository.WorkingTree.update_dir_cache/3."},{"ref":"Xgit.Plumbing.UpdateIndex.CacheInfo.html#t:add_entry/0","title":"Xgit.Plumbing.UpdateIndex.CacheInfo.add_entry/0","type":"type","doc":"Cache info tuple {mode, object_id, path} to add to the index file."},{"ref":"Xgit.Plumbing.UpdateIndex.CacheInfo.html#t:reason/0","title":"Xgit.Plumbing.UpdateIndex.CacheInfo.reason/0","type":"type","doc":"Reason codes that can be returned by run/2."},{"ref":"Xgit.Repository.html","title":"Xgit.Repository","type":"behaviour","doc":"Represents an abstract git repository. Looking for Typical Git Commands? The operations to inspect or mutate a git repository are not located in this module. (See Design Goals, below, and the README.md file in the lib/xgit folder for an explanation.) You&#39;ll find these operations in the modules named Xgit.Api.* (none yet as of this writing) and Xgit.Plumbing.* Design Goals Xgit intends to allow repositories to be stored in multiple different mechanisms. While it includes built-in support for local on-disk repositories (see Xgit.Repository.OnDisk), and in-lib repositories (see Xgit.Repository.InMemory), you could envision repositories stored entirely on a remote file system or database. Implementing a Storage Architecture To define a new mechanism for storing a git repo, start by creating a new module that uses this module and implements the required callbacks. Consider the information stored in a typical .git directory in a local repository. You will be building an alternative to that storage mechanism."},{"ref":"Xgit.Repository.html#child_spec/1","title":"Xgit.Repository.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Repository.html#default_working_tree/1","title":"Xgit.Repository.default_working_tree/1","type":"function","doc":"Get the default working tree if one has been attached. Other working trees may also be attached to this repository, but do not have special status with regard to the repository."},{"ref":"Xgit.Repository.html#get_object/2","title":"Xgit.Repository.get_object/2","type":"function","doc":"Retrieves an object from the repository. Return Value {:ok, object} if the object exists in the database. {:error, :not_found} if the object does not exist in the database. {:error, :invalid_object} if object was found, but invalid."},{"ref":"Xgit.Repository.html#c:handle_get_object/2","title":"Xgit.Repository.handle_get_object/2","type":"callback","doc":"Retrieves an object from the repository. Called when get_object/2 is called. Return Value Should return {:ok, object, state} if read successfully. Should return {:error, :not_found, state} if unable to find the object. Should return {:error, :invalid_object, state} if object was found, but invalid."},{"ref":"Xgit.Repository.html#c:handle_put_loose_object/2","title":"Xgit.Repository.handle_put_loose_object/2","type":"callback","doc":"Writes a loose object to the repository. Called when put_loose_object/2 is called. Return Value Should return {:ok, state} if written successfully. Should return {:error, :cant_create_file} if unable to create the storage for the loose object. Should return {:error, :object_exists} if the object already exists in the database."},{"ref":"Xgit.Repository.html#put_loose_object/2","title":"Xgit.Repository.put_loose_object/2","type":"function","doc":"Writes a loose object to the repository. Return Value :ok if written successfully. {:error, :cant_create_file} if unable to create the storage for the loose object. {:error, :object_exists} if the object already exists in the database."},{"ref":"Xgit.Repository.html#set_default_working_tree/2","title":"Xgit.Repository.set_default_working_tree/2","type":"function","doc":"Attach a working tree to this repository as the default working tree. Future plumbing and API commands that target this repository will use this working tree unless otherwise dictated. Return Value :ok if the working tree was successfully attached. :error if a working tree was already attached or the proposed working tree was not valid."},{"ref":"Xgit.Repository.html#start_link/3","title":"Xgit.Repository.start_link/3","type":"function","doc":"Starts a Repository process linked to the current process. IMPORTANT: You should not invoke this function directly unless you are implementing a new storage implementation module that implements this behaviour. Parameters module is the name of a module that implements the callbacks defined in this module. init_arg is passed to the init/1 function of module. options are passed to GenServer.start_link/3. Return Value See GenServer.start_link/3."},{"ref":"Xgit.Repository.html#valid?/1","title":"Xgit.Repository.valid?/1","type":"function","doc":"Returns true if the argument is a PID representing a valid Repository process."},{"ref":"Xgit.Repository.html#t:get_object_reason/0","title":"Xgit.Repository.get_object_reason/0","type":"type","doc":"Error codes that can be returned by get_object/2."},{"ref":"Xgit.Repository.html#t:put_loose_object_reason/0","title":"Xgit.Repository.put_loose_object_reason/0","type":"type","doc":"Error codes that can be returned by put_loose_object/2."},{"ref":"Xgit.Repository.html#t:t/0","title":"Xgit.Repository.t/0","type":"type","doc":"The process ID for a Repository process."},{"ref":"Xgit.Repository.InMemory.html","title":"Xgit.Repository.InMemory","type":"module","doc":"Implementation of Xgit.Repository that stores content in memory. WARNING: This is intended for testing purposes only. As the name implies, repository content is stored only in memory. When the process that implements this repository terminates, the content it stores is lost."},{"ref":"Xgit.Repository.InMemory.html#child_spec/1","title":"Xgit.Repository.InMemory.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Repository.InMemory.html#start_link/1","title":"Xgit.Repository.InMemory.start_link/1","type":"function","doc":"Start an in-memory git repository. Use the functions in Xgit.Repository to interact with this repository process. Any options are passed through to GenServer.start_link/3. Return Value See GenServer.start_link/3."},{"ref":"Xgit.Repository.OnDisk.html","title":"Xgit.Repository.OnDisk","type":"module","doc":"Implementation of Xgit.Repository that stores content on the local file system. IMPORTANT NOTE: This is intended as a reference implementation largely for testing purposes and may not necessarily handle all of the edge cases that the traditional git command-line interface will handle. That said, it does intentionally use the same .git folder format as command-line git so that results may be compared for similar operations."},{"ref":"Xgit.Repository.OnDisk.html#child_spec/1","title":"Xgit.Repository.OnDisk.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Repository.OnDisk.html#create/1","title":"Xgit.Repository.OnDisk.create/1","type":"function","doc":"Creates a new, empty git repository on the local file system. Analogous to git init. NOTE: We use the name create here so as to avoid a naming conflict with GenServer.init/1. Parameters work_dir (String) is the top-level working directory. A .git directory is created inside this directory. Return Value :ok if created successfully. {:error, :work_dir_must_not_exist} if work_dir already exists."},{"ref":"Xgit.Repository.OnDisk.html#start_link/1","title":"Xgit.Repository.OnDisk.start_link/1","type":"function","doc":"Start an on-disk git repository. Use the functions in Xgit.Repository to interact with this repository process. An Xgit.Repository.WorkingTree will be automatically created and attached to this repository. Options :work_dir (required): Top-level working directory. A .git directory should exist at this path. Use create/1 to create an empty on-disk repository if necessary. Any other options are passed through to GenServer.start_link/3. Return Value See GenServer.start_link/3."},{"ref":"Xgit.Repository.WorkingTree.html","title":"Xgit.Repository.WorkingTree","type":"module","doc":"A working tree is an on-disk manifestation of a commit or pending commit in a git repository. An Xgit.Repository may have a default working tree associated with it or it may not. (Such a repository is often referred to as a &quot;bare&quot; repository.) More than one working tree may be associated with a repository, though this is not (currently) well-tested in Xgit. A working tree is itself strictly tied to a file system, but it need not be tied to an on-disk repository instance. IMPORTANT NOTE: This is intended as a reference implementation largely for testing purposes and may not necessarily handle all of the edge cases that the traditional git command-line interface will handle."},{"ref":"Xgit.Repository.WorkingTree.html#child_spec/1","title":"Xgit.Repository.WorkingTree.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Repository.WorkingTree.html#dir_cache/1","title":"Xgit.Repository.WorkingTree.dir_cache/1","type":"function","doc":"Returns a current snapshot of the working tree state. Return Value {:ok, dir_cache} if an index file exists and could be parsed as a dir cache file. {:ok, dir_cache} if no index file exists. (dir_cache will have zero entries.) {:error, reason} if the file exists but could not be parsed. See Xgit.Repository.WorkingTree.ParseIndexFile.from_iodevice/1 for possible reason codes. TO DO Find index file in appropriate location (i.e. as potentially modified by .git/config file). Issue #86 Cache state of index file so we don&#39;t have to parse it for every call. Issue #87 Consider scalability of passing a potentially large Xgit.Core.DirCache structure across process boundaries. Issue #88"},{"ref":"Xgit.Repository.WorkingTree.html#start_link/3","title":"Xgit.Repository.WorkingTree.start_link/3","type":"function","doc":"Starts a WorkingTree process linked to the current process. Parameters repository is the associated Xgit.Repository process. work_dir is the root path for the working tree. options are passed to GenServer.start_link/3. Return Value See GenServer.start_link/3. If the process is unable to create the working directory root, the response will be {:error, {:mkdir, :eexist}} (or perhaps a different posix error code)."},{"ref":"Xgit.Repository.WorkingTree.html#update_dir_cache/3","title":"Xgit.Repository.WorkingTree.update_dir_cache/3","type":"function","doc":"Apply updates to the dir cache and rewrite the index tree accordingly. Parameters add: a list of Xgit.Core.DirCache.Entry structs to add to the dir cache. In the event of collisions with existing entries, the existing entries will be replaced with the corresponding new entries. remove: a list of {path, stage} tuples to remove from the dir cache. stage must be 0..3 to remove a specific stage entry or :all to match any entry for the path. Return Values {:ok, dir_cache} where dir_cache is the original dir_cache with the new entries added (and properly sorted) and targeted entries removed. {:error, :reason} if unable. The relevant reason codes may come from: Xgit.Core.DirCache.add_entries/2 Xgit.Core.DirCache.remove_entries/2 Xgit.Repository.WorkingTree.ParseIndexFile.from_iodevice/1 Xgit.Repository.WorkingTree.WriteIndexFile.to_iodevice/2. TO DO Find index file in appropriate location (i.e. as potentially modified by .git/config file). Issue #86 Cache state of index file so we don&#39;t have to parse it for every call. Issue #87"},{"ref":"Xgit.Repository.WorkingTree.html#valid?/1","title":"Xgit.Repository.WorkingTree.valid?/1","type":"function","doc":"Returns true if the argument is a PID representing a valid WorkingTree process."},{"ref":"Xgit.Repository.WorkingTree.html#t:t/0","title":"Xgit.Repository.WorkingTree.t/0","type":"type","doc":"The process ID for a WorkingTree process."},{"ref":"Xgit.Repository.WorkingTree.html#t:update_dir_cache_reason/0","title":"Xgit.Repository.WorkingTree.update_dir_cache_reason/0","type":"type","doc":"Error code reasons returned by update_dir_cache/3."},{"ref":"Xgit.Repository.WorkingTree.ParseIndexFile.html","title":"Xgit.Repository.WorkingTree.ParseIndexFile","type":"module","doc":"Parse a git index file and turn it into a corresponding Xgit.Core.DirCache structure."},{"ref":"Xgit.Repository.WorkingTree.ParseIndexFile.html#from_iodevice/1","title":"Xgit.Repository.WorkingTree.ParseIndexFile.from_iodevice/1","type":"function","doc":"Read index file from an IO.device (typically an opened file) and returns a corresponding Xgit.Core.DirCache struct. IMPORTANT: The IO.device must be created using Xgit.Util.TrailingHashDevice. Return Value {:ok, dir_cache} if the iodevice contains a valid index file. {:error, :not_sha_hash_device} if the iodevice was not created using Xgit.Util.TrailingHashDevice. {:error, :invalid_format} if the iodevice can not be parsed as an index file. {:error, :unsupported_version} if the index file is not a version 2 index file. Other versions are not supported at this time. {:error, :too_many_entries} if the index files contains more than 100,000 entries. This is an arbitrary limit to guard against malformed files and to prevent overconsumption of memory. With experience, it could be revisited. {:error, :extensions_not_supported} if any index file extensions are present. Parsing extensions is not yet supported. (See issue #67.) {:error, :sha_hash_mismatch} if the SHA-1 hash written at the end of the file does not match the file contents."},{"ref":"Xgit.Repository.WorkingTree.ParseIndexFile.html#t:from_iodevice_reason/0","title":"Xgit.Repository.WorkingTree.ParseIndexFile.from_iodevice_reason/0","type":"type","doc":"Error codes which can be returned by from_iodevice/1."},{"ref":"Xgit.Repository.WorkingTree.WriteIndexFile.html","title":"Xgit.Repository.WorkingTree.WriteIndexFile","type":"module","doc":"Save an Xgit.Core.DirCache to the corresponding git index file data structure."},{"ref":"Xgit.Repository.WorkingTree.WriteIndexFile.html#to_iodevice/2","title":"Xgit.Repository.WorkingTree.WriteIndexFile.to_iodevice/2","type":"function","doc":"Write index file to an iodevice (typically an opened file) from an Xgit.Core.DirCache struct. IMPORTANT: The iodevice must be created using Xgit.Util.TrailingHashDevice. Return Value :ok if written successfully. {:error, :not_sha_hash_device} if the iodevice was not created using Xgit.Util.TrailingHashDevice. {:error, :invalid_dir_cache} if Xgit.Core.DirCache.valid?/1 does not return true for this struct. {:error, :unsupported_version} if the version flag in the dir cache struct is not version. Other versions are not supported at this time. {:error, posix_reason} if an I/O error occurs."},{"ref":"Xgit.Repository.WorkingTree.WriteIndexFile.html#t:to_iodevice_reason/0","title":"Xgit.Repository.WorkingTree.WriteIndexFile.to_iodevice_reason/0","type":"type","doc":"Error codes which can be returned by to_iodevice/1."},{"ref":"Xgit.Util.Comparison.html","title":"Xgit.Util.Comparison","type":"module","doc":"Common vocabulary for data types that can be compared and/or sorted."},{"ref":"Xgit.Util.Comparison.html#t:result/0","title":"Xgit.Util.Comparison.result/0","type":"type","doc":"Result of a comparison."},{"ref":"Xgit.Util.FileSnapshot.html","title":"Xgit.Util.FileSnapshot","type":"module","doc":"Caches when a file was last read, making it possible to detect future edits. This object tracks the last modified time of a file. Later during an invocation of modified?/2 the object will return true if the file may have been modified and should be re-read from disk. A snapshot does not &quot;live update&quot; when the underlying filesystem changes. Callers must poll for updates by periodically invoking modified?/2. To work around the &quot;racy git&quot; problem (where a file may be modified multiple times within the granularity of the filesystem modification clock) this class may return true from modified?/2 if the last modification time of the file is less than 3 seconds ago."},{"ref":"Xgit.Util.FileSnapshot.html#dirty/0","title":"Xgit.Util.FileSnapshot.dirty/0","type":"function","doc":"An Xgit.Util.FileSnapshot that is considered to always be modified. This instance is useful for application code that wants to lazily read a file, but only after modified?/2 gets invoked. This snapshot instance contains only invalid status information."},{"ref":"Xgit.Util.FileSnapshot.html#missing_file/0","title":"Xgit.Util.FileSnapshot.missing_file/0","type":"function","doc":"An Xgit.Util.FileSnapshot that is clean if the file does not exist. This instance is useful if the application wants to consider a missing file to be clean. modified?/2 will return false if the file path does not exist."},{"ref":"Xgit.Util.FileSnapshot.html#modified?/2","title":"Xgit.Util.FileSnapshot.modified?/2","type":"function","doc":"Return true if the path may have been modified since the snapshot was saved."},{"ref":"Xgit.Util.FileSnapshot.html#save/1","title":"Xgit.Util.FileSnapshot.save/1","type":"function","doc":"Record a snapshot for a specific file path. This function should be invoked before the file is accessed."},{"ref":"Xgit.Util.FileSnapshot.html#set_clean/2","title":"Xgit.Util.FileSnapshot.set_clean/2","type":"function","doc":"Update this snapshot when the content hasn&#39;t changed. If the caller gets true from modified?/2, re-reads the content, discovers the content is identical, it can use to make a future call to modified?/2 return false. A typical invocation looks something like this: new_snapshot = if FileSnapshot.modified?(snapshot, path) do other = FileSnapshot.save(path) if old_content_matches_new_content? and snapshot.last_modified == other.last_modified do FileSnapshot.set_clean(snapshot, other) else snapshot end else snapshot end Return Value :ok"},{"ref":"Xgit.Util.FileSnapshot.html#t:t/0","title":"Xgit.Util.FileSnapshot.t/0","type":"type","doc":"Cache for when a file was last saved. Struct Members last_modified: Last observed modification time of the path. ref: Reference into a cache for when this file was last read."},{"ref":"Xgit.Util.NB.html","title":"Xgit.Util.NB","type":"module","doc":"Conversion utilities for network byte order handling."},{"ref":"Xgit.Util.NB.html#decode_int32/1","title":"Xgit.Util.NB.decode_int32/1","type":"function","doc":"Parses a sequence of 4 bytes (network byte order) as a signed integer. Reads the first four bytes from intbuf and returns {value, buf} where value is the integer value from the first four bytes at intbuf and buf is the remainder of the byte array after those bytes."},{"ref":"Xgit.Util.NB.html#decode_uint16/1","title":"Xgit.Util.NB.decode_uint16/1","type":"function","doc":"Parses a sequence of 2 bytes (network byte order) as an unsigned integer. Reads the first four bytes from intbuf and returns {value, buf} where value is the unsigned integer value from the first two bytes at intbuf and buf is the remainder of the byte array after those bytes."},{"ref":"Xgit.Util.NB.html#decode_uint32/1","title":"Xgit.Util.NB.decode_uint32/1","type":"function","doc":"Parses a sequence of 4 bytes (network byte order) as an unsigned integer. Reads the first four bytes from intbuf and returns {value, buf} where value is the unsigned integer value from the first four bytes at intbuf and buf is the remainder of the byte array after those bytes."},{"ref":"Xgit.Util.NB.html#encode_int16/1","title":"Xgit.Util.NB.encode_int16/1","type":"function","doc":"Convert a 16-bit integer to a sequence of two bytes in network byte order."},{"ref":"Xgit.Util.NB.html#encode_int32/1","title":"Xgit.Util.NB.encode_int32/1","type":"function","doc":"Convert a 32-bit integer to a sequence of four bytes in network byte order."},{"ref":"Xgit.Util.NB.html#encode_uint16/1","title":"Xgit.Util.NB.encode_uint16/1","type":"function","doc":"Convert a 16-bit unsigned integer to a sequence of two bytes in network byte order."},{"ref":"Xgit.Util.NB.html#encode_uint32/1","title":"Xgit.Util.NB.encode_uint32/1","type":"function","doc":"Convert a 32-bit unsigned integer to a sequence of four bytes in network byte order."},{"ref":"Xgit.Util.RawParseUtils.html","title":"Xgit.Util.RawParseUtils","type":"module","doc":"Handy utility functions to parse raw object contents."},{"ref":"Xgit.Util.RawParseUtils.html#after_prefix/2","title":"Xgit.Util.RawParseUtils.after_prefix/2","type":"function","doc":"Return the portion of the charlist b that starts with the prefix prefix. Return Values If b does in fact start with prefix, return the portion of the charlist that follows prefix. If not, return nil."},{"ref":"Xgit.Util.RawParseUtils.html#author/1","title":"Xgit.Util.RawParseUtils.author/1","type":"function","doc":"Locate the author header line data. Returns a charlist beginning just after the space in author which should be the first character of the author&#39;s name. If no author header can be located, nil is returned."},{"ref":"Xgit.Util.RawParseUtils.html#committer/1","title":"Xgit.Util.RawParseUtils.committer/1","type":"function","doc":"Locate the committer header line data. Returns a charlist beginning just after the space in committer which should be the first character of the committer&#39;s name. If no committer header can be located, nil is returned."},{"ref":"Xgit.Util.RawParseUtils.html#decode/1","title":"Xgit.Util.RawParseUtils.decode/1","type":"function","doc":"Convert a list of bytes to an Elixir (UTF-8) string when the encoding is not definitively known. Try parsing as a UTF-8 byte array first, then try ISO-8859-1. PORTING NOTE: A lot of the simplification of this compared to jgit&#39;s implementation of RawParseUtils.decode comes from the observation that the only character set ever passed to jgit&#39;s decode was UTF-8. We&#39;ve baked that assumption into this implementation. Should other character sets come into play, this will necessarily become more complicated."},{"ref":"Xgit.Util.RawParseUtils.html#encoding/1","title":"Xgit.Util.RawParseUtils.encoding/1","type":"function","doc":"Locate the encoding header line data. Returns a charlist beginning just after the space in encoding which should be the first character of the encoding&#39;s name. If no encoding header can be located, nil is returned (and UTF-8 should be assumed)."},{"ref":"Xgit.Util.RawParseUtils.html#header_end/1","title":"Xgit.Util.RawParseUtils.header_end/1","type":"function","doc":"Locate the end of the header. Note that headers may be more than one line long. Returns charlist beginning just after the header. This is either [] or the charlist beginning with the \\n character that terminates the header."},{"ref":"Xgit.Util.RawParseUtils.html#header_start/2","title":"Xgit.Util.RawParseUtils.header_start/2","type":"function","doc":"Find the start of the contents of a given header in the given charlist. Returns charlist beginning at the start of the header&#39;s contents or nil if not found. PORTING NOTE: Unlike the jgit version of this function, it does not advance to the beginning of the next line. Because the API speaks in charlists, we cannot differentiate between the beginning of the initial string buffer and a subsequent internal portion of the buffer. Clients may need to add their own call to next_lf/1 where it would not have been necessary in jgit."},{"ref":"Xgit.Util.RawParseUtils.html#next/2","title":"Xgit.Util.RawParseUtils.next/2","type":"function","doc":"Locate the first position after a given character."},{"ref":"Xgit.Util.RawParseUtils.html#next_lf/1","title":"Xgit.Util.RawParseUtils.next_lf/1","type":"function","doc":"Locate the first position after the next LF. This method stops on the first \\n it finds."},{"ref":"Xgit.Util.RawParseUtils.html#next_lf/2","title":"Xgit.Util.RawParseUtils.next_lf/2","type":"function","doc":"Locate the first position of either the given character or LF. This method stops on the first match it finds from either char or \\n."},{"ref":"Xgit.Util.RawParseUtils.html#parse_base_10/1","title":"Xgit.Util.RawParseUtils.parse_base_10/1","type":"function","doc":"Parse a base-10 numeric value from a charlist of ASCII digits into a number. Similar to Integer.parse/2 but uses charlist instead. Digit sequences can begin with an optional run of spaces before the sequence, and may start with a + or a - to indicate sign position. Any other characters will cause the method to stop and return the current result to the caller. Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_encoding/1","title":"Xgit.Util.RawParseUtils.parse_encoding/1","type":"function","doc":"Parse the encoding header into a character set reference. Returns :utf8 or :latin1. Raises ArgumentError if the character set is unknown. WARNING: Compared to jgit, the character set support in xgit is limited."},{"ref":"Xgit.Util.RawParseUtils.html#parse_encoding_name/1","title":"Xgit.Util.RawParseUtils.parse_encoding_name/1","type":"function","doc":"Parse the encoding header as a string. Returns the encoding header as specified in the commit or nil if the header was not present and UTF-8 should be assumed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int16/1","title":"Xgit.Util.RawParseUtils.parse_hex_int16/1","type":"function","doc":"Parse 4 hex digits from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int32/1","title":"Xgit.Util.RawParseUtils.parse_hex_int32/1","type":"function","doc":"Parse 8 hex digits from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int4/1","title":"Xgit.Util.RawParseUtils.parse_hex_int4/1","type":"function","doc":"Parse a single hex digit from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_hex_int64/1","title":"Xgit.Util.RawParseUtils.parse_hex_int64/1","type":"function","doc":"Parse 16 hex digits from a byte list to an integer. The number is read in network byte order, that is, most significant nybble first. Return Value Returns {number, new_buffer} where number is the integer that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#parse_timezone_offset/1","title":"Xgit.Util.RawParseUtils.parse_timezone_offset/1","type":"function","doc":"Parse a git-style timezone string. The sequence -0315 will be parsed as the numeric value -195, as the lower two positions count minutes, not 100ths of an hour. Return Value Returns {number, new_buffer} where number is the time zone offset in minutes that was found (or 0 if no number found there) and new_buffer is the charlist following the number that was parsed."},{"ref":"Xgit.Util.RawParseUtils.html#tagger/1","title":"Xgit.Util.RawParseUtils.tagger/1","type":"function","doc":"Locate the tagger header line data. Returns a charlist beginning just after the space in tagger which should be the first character of the tagger&#39;s name. If no tagger header can be located, nil is returned."},{"ref":"Xgit.Util.RawParseUtils.html#until_end_of_paragraph/1","title":"Xgit.Util.RawParseUtils.until_end_of_paragraph/1","type":"function","doc":"Return the contents of the charlist up to, but not including, the next end-of-paragraph sequence."},{"ref":"Xgit.Util.RawParseUtils.html#until_last_instance_of_trim/2","title":"Xgit.Util.RawParseUtils.until_last_instance_of_trim/2","type":"function","doc":"Return the portion of the byte array up to, but not including the last instance of ch, disregarding any trailing spaces."},{"ref":"Xgit.Util.RawParseUtils.html#until_next_lf/1","title":"Xgit.Util.RawParseUtils.until_next_lf/1","type":"function","doc":"Return the contents of the charlist up to, but not including, the next LF."},{"ref":"Xgit.Util.RawParseUtils.html#until_next_lf/2","title":"Xgit.Util.RawParseUtils.until_next_lf/2","type":"function","doc":"Return the contents of the charlist up to, but not including, the next instance of the given character or LF."},{"ref":"Xgit.Util.TrailingHashDevice.html","title":"Xgit.Util.TrailingHashDevice","type":"module","doc":"Creates an iodevice process that supports git file formats with a trailing SHA-1 hash. When reading, the trailing 20 bytes are interpreted as a SHA-1 hash of the remaining file contents and can be verified using the valid_hash?/1 function. This is an admittedly minimal implementation; just enough is implemented to allow Xgit&#39;s index file parser to do its work."},{"ref":"Xgit.Util.TrailingHashDevice.html#child_spec/1","title":"Xgit.Util.TrailingHashDevice.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xgit.Util.TrailingHashDevice.html#open_file/1","title":"Xgit.Util.TrailingHashDevice.open_file/1","type":"function","doc":"Creates an IO device that reads a file with trailing hash. Unlike File.open/2 and File.open/3, no options or function are accepted. This device can be passed to IO.binread/2. Return Value {:ok, pid} where pid points to an IO device process. {:ok, reason} if the file could not be opened. See File.open/2 for possible values for reason."},{"ref":"Xgit.Util.TrailingHashDevice.html#open_file_for_write/2","title":"Xgit.Util.TrailingHashDevice.open_file_for_write/2","type":"function","doc":"Creates an IO device that writes to a file with trailing hash. Unlike File.open/2 and File.open/3, no options or function are accepted. This device can be passed to IO.binwrite/2. Options :max_file_size (non-negative integer) may be passed, which will cause a failure after the _n_th byte is written. This is intended for internal testing purposes. Return Value {:ok, pid} where pid points to an IO device process. {:ok, reason} if the file could not be opened. See File.open/2 for possible values for reason."},{"ref":"Xgit.Util.TrailingHashDevice.html#open_string/1","title":"Xgit.Util.TrailingHashDevice.open_string/1","type":"function","doc":"Creates an IO device that reads a string with trailing hash. This is intended mostly for internal testing purposes. Unlike StringIO.open/2 and StringIO.open/3, no options or function are accepted. This device can be passed to IO.binread/2. Return Value {:ok, pid} where pid points to an IO device process."},{"ref":"Xgit.Util.TrailingHashDevice.html#valid?/1","title":"Xgit.Util.TrailingHashDevice.valid?/1","type":"function","doc":"Returns true if this is process is an TrailingHashDevice instance. Note the difference between this function and valid_hash?/1."},{"ref":"Xgit.Util.TrailingHashDevice.html#valid_hash?/1","title":"Xgit.Util.TrailingHashDevice.valid_hash?/1","type":"function","doc":"Returns true if the hash at the end of the file matches the hash generated while reading the file. Should only be called once and only once when the entire file (sans SHA-1 hash) has been read. Return Values true or false if the SHA-1 hash was found and was valid (or not). :too_soon if called before the SHA-1 hash is expected. :already_called if called a second (or successive) time. :opened_for_write if called on a device that was opened for write."},{"ref":"Xgit.Util.UnzipStream.html","title":"Xgit.Util.UnzipStream","type":"module","doc":"Transforms a stream from a compressed ZIP stream to uncompressed data."},{"ref":"Xgit.Util.UnzipStream.html#unzip/1","title":"Xgit.Util.UnzipStream.unzip/1","type":"function","doc":"Transforms a stream from a compressed ZIP stream to uncompressed data."}]